package org.auth_client;

import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.PublicKey;
import java.security.Security;
import java.security.Signature;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.X509EncodedKeySpec;

import java.util.List;

import org.auth_client.R;
import org.spongycastle.jce.provider.BouncyCastleProvider;
import org.spongycastle.util.encoders.Base64;
import org.spongycastle.util.io.pem.PemReader;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.hardware.Camera;
import android.hardware.Camera.CameraInfo;
import android.hardware.Camera.Parameters;
import android.hardware.Camera.Size;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.view.Window;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.zxing.BinaryBitmap;
import com.google.zxing.MultiFormatReader;
import com.google.zxing.ReaderException;
import com.google.zxing.Result;
import com.google.zxing.client.android.PlanarYUVLuminanceSource;
import com.google.zxing.client.android.camera.CameraManager;
import com.google.zxing.common.HybridBinarizer;

@TargetApi(9)
public class MainActivity extends Activity {

	barcode bar;
	public int nr = 1;
	ViewfinderView mDraw;
	MainActivity intent = this;
	boolean camera_init = false;
	boolean camera_init2 = false;
	boolean stop = false;
	

	class BackgroundLoadingTask extends AsyncTask<String, Void, Boolean> {
		Bitmap zdj;
		String dane;

		@Override
		protected void onPreExecute() {
			// show the progress bar

		}

		@Override
		protected Boolean doInBackground(String... params) {

			dane = http_lib.getPhoto(params[0],params[1],params[2],params[3]);
			Log.i("zdj", "odebrane");

			return true;
		}

		@Override
		protected void onPostExecute(Boolean parsingError) {
			// hide the progress bar

			ImageView image = (ImageView) alertDialog.findViewById(R.id.img);
			image.clearAnimation();
			image.setVisibility(ImageView.INVISIBLE);
			//image.setImageBitmap(zdj);
			
			TextView text_view = (TextView) alertDialog
					.findViewById(R.id.textView1);
			text_view.setText(dane);

		}
	}

	public static boolean close = false;
	public static Preview mPreview;
	Camera mCamera;
	int numberOfCameras;
	int cameraCurrentlyLocked;
	MultiFormatReader multiFormatReader;

	// The first rear facing camera
	int defaultCameraId;

	public static Dialog alertDialog;

	@Override
	public void onBackPressed() {

		// close = true;
		// mCamera.stopPreview();
		// this.finish();

	}

	public void createDialog() {

		Context mContext = MainActivity.this;
		alertDialog = new Dialog(mContext);

		alertDialog.setContentView(R.layout.custom_dialog);
		alertDialog.setTitle("Deszyfrowanie");
		alertDialog.setOnCancelListener(new DialogInterface.OnCancelListener() {

			public void onCancel(DialogInterface dialog) {

				alertDialog.dismiss();
				intent.nr = 1;
				bar.reset();
				
				mDraw.SetText("Zeskanuj 1 barcode");
				stop=false;
				//mCamera.startPreview();
				//AutoFocusCallBack autoFocusCallBack = new AutoFocusCallBack();
				//mCamera.autoFocus(autoFocusCallBack);
				//camera_init2 = true;
				
				//read_all();

			}
		});
		// alertDialog.setCancelable(false);

	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		stop = false;
		close = false;
		// Hide the window title.
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);

		// Create a RelativeLayout container that will hold a SurfaceView,
		// and set it as the content of our activity.
		CameraManager cameraManager = new CameraManager(getApplication());
		int width = getWindowManager().getDefaultDisplay().getWidth();
		int height = getWindowManager().getDefaultDisplay().getHeight();

		mPreview = new Preview(this);
		mDraw = new ViewfinderView(this, null);
		mDraw.setDisplay(width, height);
		setContentView(mPreview);

		addContentView(mDraw, new LayoutParams(LayoutParams.WRAP_CONTENT,
				LayoutParams.WRAP_CONTENT));
		mDraw.SetText("Zeskanuj 1 barcode");
		close = false;
		bar = new barcode(this);

		// Find the total number of cameras available
		numberOfCameras = Camera.getNumberOfCameras();

		// Find the ID of the default camera
		CameraInfo cameraInfo = new CameraInfo();
		for (int i = 0; i < numberOfCameras; i++) {
			Camera.getCameraInfo(i, cameraInfo);
			if (cameraInfo.facing == CameraInfo.CAMERA_FACING_BACK) {
				defaultCameraId = i;
			}
		}
		multiFormatReader = new MultiFormatReader();

		createDialog();

	}

	@Override
	protected void onResume() {
		super.onResume();
		close = false;
		camera_init = false;
		camera_init2 = false;
		stop = false;
		
		
		
		read_all();
		
	};
	
	private void read_all(){	
		//if (camera_init == false) {
			
			
			mCamera = Camera.open();
			camera_init = true;
			//mCamera.setDisplayOrientation(90);
			AutoFocusCallBack autoFocusCallBack = new AutoFocusCallBack();
			mCamera.autoFocus(autoFocusCallBack);
			
			cameraCurrentlyLocked = defaultCameraId;
			Parameters parameters = mCamera.getParameters();

			parameters.setZoom(parameters.getMaxZoom());
			parameters.setWhiteBalance("auto");
			parameters.setFocusMode(Parameters.FLASH_MODE_TORCH);
			Log.i("zoom", String.valueOf(parameters.getMaxZoom()));
			//mCamera.setParameters(parameters);
			//mPreview.setCamera(mCamera);
			
			
			
		//} 

		//if ((camera_init2 == false)&&(stop == false)) {
			mCamera.setPreviewCallback(

			new Camera.PreviewCallback() {
				public void onPreviewFrame(byte[] data, Camera camera) {

					Camera.Size size = camera.getParameters().getPreviewSize();
					PlanarYUVLuminanceSource source = new PlanarYUVLuminanceSource(
							data, size.width, size.height, 0, 0, size.width,
							size.height, false);
					BinaryBitmap bitmap = new BinaryBitmap(new HybridBinarizer(
							source));
					try {

						if (bar.decode(bitmap, intent.nr) & (stop == false)) {
							//Log.i("TAG_x", "if 1 !!!nr="+intent.nr);
						
							if ((stop == false)) {
								// Log.i("TAG", "if 2");
								intent.nr = 1;
								mDraw.SetText("Zeskanuj " + intent.nr
										+ " barcode");
								Log.i("TAG", "jestem");
							
									mDraw.SetText("");
									bar.process();
									

									ImageView image = (ImageView) alertDialog
											.findViewById(R.id.img);
									image.setVisibility(View.GONE);
									final Button button = (Button) alertDialog
											.findViewById(R.id.button1);
									button.setVisibility(View.VISIBLE);
									TextView text_view = (TextView) alertDialog
											.findViewById(R.id.textView1);
									text_view.setText("Najpierw pobierz dane");
							
										button.setOnClickListener(new View.OnClickListener() {
											public void onClick(View v) {
												button.setVisibility(View.GONE);
												ImageView image = (ImageView) alertDialog
														.findViewById(R.id.img);
												image.setImageResource(R.drawable.loading);
												Animation rotate = AnimationUtils
														.loadAnimation(image
																.getContext(),
																R.anim.anim);
												image.startAnimation(rotate);
												image.setVisibility(View.VISIBLE);
												Log.i("TAG", "start https");
												new BackgroundLoadingTask()
														.execute(bar.id_aes,bar.host,bar.key_aes,bar.iv_eas);
											}
										});

									stop=true;

									alertDialog.show();
								
							}

						}
					} catch (Exception e) {
						if (e.getMessage() != null)
							Log.i("TAG", e.getMessage());
					}
				}
			});
		//}

		mPreview.setCamera(mCamera);
		
		

	}

	@Override
	protected void onPause() {
		super.onPause();

		/*stop = true;
		close = true;
		if (mCamera != null) {
			mCamera.cancelAutoFocus();
			mPreview.setCamera(null);
			mCamera.setPreviewCallback(null);
			mCamera.stopPreview();
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			mCamera.release();
			mCamera = null;
			
			//close = false;
			//camera_init = false;
			//camera_init2 = false;
			
			
		}*/
	}

	protected void onStop() {
		
		super.onStop();
		Log.i("STOP", "STOP");
		stop = true;
		close = true;
		if (mCamera != null) {
			mCamera.cancelAutoFocus();
			mPreview.setCamera(null);
			mCamera.setPreviewCallback(null);
			mCamera.stopPreview();
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			mCamera.release();
			mCamera = null;
			
			//close = false;
			//camera_init = false;
			//camera_init2 = false;
			
			
		}
	}

}

class Preview extends ViewGroup implements SurfaceHolder.Callback {
	private final String TAG = "Preview";
	public AutoFocusCallBack autoFocusCallBack = new AutoFocusCallBack();

	SurfaceView mSurfaceView;
	SurfaceHolder mHolder;
	Size mPreviewSize;
	List<Size> mSupportedPreviewSizes;
	Camera mCamera;

	public int[] pixels;

	Preview(Context context) {
		super(context);

		mSurfaceView = new SurfaceView(context);
		addView(mSurfaceView);

		// Install a SurfaceHolder.Callback so we get notified when the
		// underlying surface is created and destroyed.
		mHolder = mSurfaceView.getHolder();
		mHolder.addCallback(this);
		mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
	}

	public void setCamera(Camera camera) {
		mCamera = camera;
		if (mCamera != null) {
			mSupportedPreviewSizes = mCamera.getParameters()
					.getSupportedPreviewSizes();
			requestLayout();
		}
	}

	public void switchCamera(Camera camera) {
		setCamera(camera);
		try {
			camera.setPreviewDisplay(mHolder);
		} catch (IOException exception) {
			Log.e(TAG, "IOException caused by setPreviewDisplay()", exception);
		}
		Camera.Parameters parameters = camera.getParameters();
		parameters.setPreviewSize(mPreviewSize.width, mPreviewSize.height);

		requestLayout();

		camera.setParameters(parameters);
	}

	@Override
	protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
		// We purposely disregard child measurements because act as a
		// wrapper to a SurfaceView that centers the camera preview instead
		// of stretching it.
		final int width = resolveSize(getSuggestedMinimumWidth(),
				widthMeasureSpec);
		final int height = resolveSize(getSuggestedMinimumHeight(),
				heightMeasureSpec);
		setMeasuredDimension(width, height);

		if (mSupportedPreviewSizes != null) {
			mPreviewSize = getOptimalPreviewSize(mSupportedPreviewSizes, width,
					height);
		}
	}

	@Override
	protected void onLayout(boolean changed, int l, int t, int r, int b) {
		if (changed && getChildCount() > 0) {
			final View child = getChildAt(0);

			final int width = r - l;
			final int height = b - t;

			int previewWidth = width;
			int previewHeight = height;
			if (mPreviewSize != null) {
				previewWidth = mPreviewSize.width;
				previewHeight = mPreviewSize.height;
			}

			// Center the child SurfaceView within the parent.
			if (width * previewHeight > height * previewWidth) {
				final int scaledChildWidth = previewWidth * height
						/ previewHeight;
				child.layout((width - scaledChildWidth) / 2, 0,
						(width + scaledChildWidth) / 2, height);
			} else {
				final int scaledChildHeight = previewHeight * width
						/ previewWidth;
				child.layout(0, (height - scaledChildHeight) / 2, width,
						(height + scaledChildHeight) / 2);
			}
		}
	}

	public void surfaceCreated(SurfaceHolder holder) {
		// The Surface has been created, acquire the camera and tell it where
		// to draw.
		try {
			if (mCamera != null) {
				mCamera.setPreviewDisplay(holder);
			}
		} catch (IOException exception) {
			Log.e(TAG, "IOException caused by setPreviewDisplay()", exception);
		}
	}

	public void surfaceDestroyed(SurfaceHolder holder) {
		// Surface will be destroyed when we return, so stop the preview.
		if (mCamera != null) {
			mCamera.stopPreview();
		}
	}

	private Size getOptimalPreviewSize(List<Size> sizes, int w, int h) {
		final double ASPECT_TOLERANCE = 0.1;
		double targetRatio = (double) w / h;
		if (sizes == null)
			return null;

		Size optimalSize = null;
		double minDiff = Double.MAX_VALUE;

		int targetHeight = h;

		// Try to find an size match aspect ratio and size
		for (Size size : sizes) {
			double ratio = (double) size.width / size.height;
			if (Math.abs(ratio - targetRatio) > ASPECT_TOLERANCE)
				continue;
			if (Math.abs(size.height - targetHeight) < minDiff) {
				optimalSize = size;
				minDiff = Math.abs(size.height - targetHeight);
			}
		}

		// Cannot find the one match the aspect ratio, ignore the requirement
		if (optimalSize == null) {
			minDiff = Double.MAX_VALUE;
			for (Size size : sizes) {
				if (Math.abs(size.height - targetHeight) < minDiff) {
					optimalSize = size;
					minDiff = Math.abs(size.height - targetHeight);
				}
			}
		}
		return optimalSize;
	}

	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {
		// Now that the size is known, set up the camera parameters and begin
		// the preview.
		if(mCamera!=null){
		Camera.Parameters parameters = mCamera.getParameters();
		parameters.setPreviewSize(mPreviewSize.width, mPreviewSize.height);
		requestLayout();

		mCamera.setParameters(parameters);
		mCamera.startPreview();

		mCamera.autoFocus(autoFocusCallBack);
		}
	}

}
