package org.auth_client;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;

import org.spongycastle.util.encoders.Base64;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.util.Log;

public class http_lib {
	// always verify the host - dont check for certificate
    final static HostnameVerifier DO_NOT_VERIFY = new HostnameVerifier() {
          public boolean verify(String hostname, SSLSession session) {
              return true;
          }
   };


    /**
     * Trust every server - dont check for any certificate
     */
    private static void trustAllHosts() {
              // Create a trust manager that does not validate certificate chains
    	TrustManager[] trustAllCerts = new TrustManager[] { new NaiveTrustManager() };


              // Install the all-trusting trust manager
              try {
                      SSLContext sc = SSLContext.getInstance("TLS");
                      sc.init(null, trustAllCerts, new java.security.SecureRandom());
                      HttpsURLConnection
                                      .setDefaultSSLSocketFactory(sc.getSocketFactory());
              } catch (Exception e) {
                      e.printStackTrace();
              }
      }
	
	
	public static String getPhoto(String id_aes,String host,String key, String iv){
	//String http_path = "156.17.7.12";
		String http_path = host+":3000";
	String csrf_token = "";
    String cook = "";
    String auth_token = "";
    
    
    
    try {

       
        
   //////////////////////////////////////////////////////////////////     
     

      String data = URLEncoder.encode("id", "UTF-8") + "=" + URLEncoder.encode(id_aes, "UTF-8"); 
      URL url = new URL("http://"+http_path+"/android/img");
      HttpURLConnection conn = (HttpURLConnection)url.openConnection();
       

       
        conn.setDoOutput(true);
        conn.connect();
        OutputStreamWriter wr2 = new OutputStreamWriter(conn.getOutputStream());
        wr2.write(data);
        wr2.flush();

        wr2.close();
              
        BufferedInputStream in = new BufferedInputStream(conn.getInputStream());
   ByteArrayOutputStream byteArrayOut = new ByteArrayOutputStream();
   int c;
   while ((c = in.read()) != -1) {
     byteArrayOut.write(c);
   }
   String encoded = byteArrayOut.toString("UTF-8");
   Log.i("TAG", encoded);
   final Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
   cipher.init(Cipher.DECRYPT_MODE, new SecretKeySpec(Base64.decode(key), "AES"), new IvParameterSpec(Base64.decode(iv), 0, cipher.getBlockSize()));
   byte[] decrypted = cipher.doFinal(Base64.decode(encoded));
      
   //Bitmap bm = BitmapFactory.decodeByteArray(byteArrayOut.toByteArray(), 0, byteArrayOut.toByteArray().length);
 
     
     return new String(decrypted,"UTF-8");
        
        
    } catch (MalformedURLException ex) {
    	Log.i("http_lib", ex.getMessage());
    	return "";
    } catch (IOException ex2) {
    	Log.i("http_lib", ex2.getMessage());
    	return "";
    } catch (NoSuchAlgorithmException e) {
		// TODO Auto-generated catch block
    	
		e.printStackTrace();
		return "";
	} catch (NoSuchPaddingException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		return "";
	} catch (InvalidKeyException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		return "";
	} catch (InvalidAlgorithmParameterException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (IllegalBlockSizeException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		return "";
	} catch (BadPaddingException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		return "";
	}
	return "";
	
	}

	
	private static Bitmap getResizedBitmap(Bitmap bm, int newHeight, int newWidth) {
	    int width = bm.getWidth();
	    int height = bm.getHeight();
	    float scaleWidth = ((float) newWidth) / width;
	    float scaleHeight = ((float) newHeight) / height;
	    // CREATE A MATRIX FOR THE MANIPULATION
	    Matrix matrix = new Matrix();
	    // RESIZE THE BIT MAP
	    matrix.postScale(scaleWidth, scaleHeight);

	    // "RECREATE" THE NEW BITMAP
	    Bitmap resizedBitmap = Bitmap.createBitmap(bm, 0, 0, width, height, matrix, false);
	    return resizedBitmap;
	}
	
	
}
